﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9
@EndOfDesignText@
#Event: Swipe (DeltaX As Float, DeltaY As Float)
Sub Class_Globals
	Public base As B4XView
	Private TouchXStart, TouchYStart As Float
	Private HandlingSwipe As Boolean
	Private overlay As Panel
	Private xui As XUI
	Private mCallback As Object
	Private mEventName As String
End Sub

Public Sub Initialize (Callback As Object, EventName As String, Parent As B4XView)
	Dim tc As TouchPanelCreator
	base = tc.CreateTouchPanel("base")
	Parent.AddView(base, 0, 0, Parent.Width, Parent.Height)
	overlay = xui.CreatePanel("")
	overlay.Color = 0x330099FF
	base.AddView(overlay, 0, 0.7 * Parent.Height, Parent.Width, 0.3 * Parent.Height)
	overlay.Elevation = 4dip
	
	mCallback = Callback
	mEventName = EventName
	overlay.Visible = False	
	AnimateOverlay
End Sub

Private Sub AnimateOverlay
	Sleep(500)
	overlay.Visible = True
	overlay.SetVisibleAnimated(1000, False)
End Sub

Private Sub Base_OnInterceptTouchEvent (Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Select Action
		Case base.TOUCH_ACTION_DOWN
			TouchXStart = X
			TouchYStart = Y
			HandlingSwipe = False
		Case base.TOUCH_ACTION_MOVE
			Dim dx As Float = Abs(x - TouchXStart)
			If dx > 5dip And TouchYStart >  0.7 * base.Height Then
				HandlingSwipe = True
				overlay.Visible = True
			End If
		Case base.TOUCH_ACTION_UP
			overlay.Visible = False
	End Select
	Return HandlingSwipe
End Sub

Private  Sub base_OnTouchEvent (Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Select Action
		Case base.TOUCH_ACTION_UP
			Dim dx As Float = x - TouchXStart
			Dim dy As Float = y - TouchYStart
			CallSub3(mCallback, mEventName & "_Swipe", dx, dy)
			overlay.Visible = False
	End Select
	Return True
End Sub